/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __draw_ViewCommon_h__
#define __draw_ViewCommon_h__

namespace fe
{

/**************************************************************************//**
	@brief general-implementation methods for ViewI

	@ingroup draw
*//***************************************************************************/
class FE_DL_EXPORT ViewCommon: virtual public ViewI
{
	public:
							ViewCommon(void);

							//* as ViewI
virtual	void				setWindow(sp<WindowI> spWindowI)
							{	m_spWindowI=spWindowI; }
virtual	sp<WindowI>			window(void) const
							{	return m_spWindowI; }

virtual	void				setCameraDisplay(sp<CameraDisplay> spCameraDisplay)
							{	m_spCameraDisplay=spCameraDisplay; }
virtual	sp<CameraDisplay>	cameraDisplay(void) const
							{	return m_spCameraDisplay; }

virtual	void				screenAlignment(SpatialTransform& a_rotation);

virtual	void				screenInfo(Real &a_screenScale,
								SpatialVector &a_screenLocation,
								const SpatialTransform& a_rotation,
								const SpatialVector &a_location);

virtual	void				use(CameraI::Projection a_projection)			{}

virtual	SpatialVector		unproject(Real winx,Real winy,Real winz,
									CameraI::Projection a_projection=
									CameraI::e_current) const
							{	return SpatialVector(0.0,0.0,0.0); }

virtual	SpatialVector		project(const SpatialVector& point,
									CameraI::Projection a_projection=
									CameraI::e_current) const
							{	return SpatialVector(0.0,0.0,0.0); }

virtual	Real				pixelSize(const SpatialVector& center,
									Real radius) const		{ return 0.0; }

virtual	Real				worldSize(const SpatialVector& center,
									Real pixels) const		{ return 0.0; }

static	Matrix<4,4,Real>	computeOrtho(Real a_zoom,
								const Vector<2,Real> &a_center,
								const Vector<2,Real> &a_size);

	protected:
		sp<CameraDisplay>	m_spCameraDisplay;

	private:
		sp<WindowI>			m_spWindowI;
};

} // namespace

#endif /* __draw_ViewCommon_h__ */
